--[[
	BActionButtonMain
		The event handler for Bongos ActonBars and ActionButtons
		
	TODO:
		Make it faster.
--]]

bg_showGrid = nil; --is determines if empty buttons are being shown or not.

--Called by BMain
function BActionMain_Load()
	--create the event frame
	CreateFrame("Frame", "BActionMain", nil);
	BActionMain:Hide();
	BActionMain.elapsed = 0;
	BActionMain:SetScript("OnEvent", BActionMain_OnEvent);
	BActionMain:SetScript("OnUpdate", BActionMain_OnUpdate);
	
	--override functions 
	ActionBar_PageUp = BActionBar_PageUp;
	ActionBar_PageDown = BActionBar_PageDown;
	
	ActionButtonUp = BActionButtonUp; 
	ActionButtonDown = BActionButtonDown;
	
	--Register Events
	BActionMain_RegisterEvents();
	
	--Create actionbars
	for i = 1, Bongos.numActionBars do
		BActionBar_Create();
	end
	BActionMain_UpdateOnUpdate();
end

--[[ OnUpdate ]]--

function BActionMain_OnUpdate()
	if( not bg_quickPaged and Bongos_IsSelfCastHotkeyDown() ) then
		bg_quickPaged = 1;
		for i=1, Bongos.numActionBars do
			if(Bongos[i].inContext) then
				BActionMain_UpdateBar(i);
			end
		end
	elseif( bg_quickPaged and not Bongos_IsSelfCastHotkeyDown() ) then
		bg_quickPaged = nil;
		for i=1, Bongos.numActionBars do
			if(Bongos[i].inContext) then
				BActionMain_UpdateBar(i);
			end
		end
	end
	
	if( Bongos.preventMash and bg_timeSinceLastHit ) then
		for id in bg_timeSinceLastHit do
			bg_timeSinceLastHit[id] = bg_timeSinceLastHit[id] - arg1;
			if( bg_timeSinceLastHit[id] <= 0) then
				bg_timeSinceLastHit[id] = nil;
			end
		end
	end
end

--[[ Event Handler ]]--

function BActionMain_RegisterEvents()
	BActionMain:RegisterEvent("PLAYER_TARGET_CHANGED");
	BActionMain:RegisterEvent("ACTIONBAR_PAGE_CHANGED");
	BActionMain:RegisterEvent("PLAYER_AURAS_CHANGED");
	BActionMain:RegisterEvent("UPDATE_BONUS_ACTIONBAR");
	BActionMain:RegisterEvent("ACTIONBAR_SHOWGRID");
	BActionMain:RegisterEvent("ACTIONBAR_HIDEGRID");
	BActionMain:RegisterEvent("UPDATE_BINDINGS");
	
	BActionMain:RegisterEvent("ACTIONBAR_UPDATE_STATE");
	BActionMain:RegisterEvent("ACTIONBAR_UPDATE_USABLE");
	BActionMain:RegisterEvent("ACTIONBAR_UPDATE_COOLDOWN");
	BActionMain:RegisterEvent("UPDATE_INVENTORY_ALERTS");
	BActionMain:RegisterEvent("UNIT_AURASTATE");
	BActionMain:RegisterEvent("CRAFT_SHOW");
	BActionMain:RegisterEvent("CRAFT_CLOSE");
	BActionMain:RegisterEvent("TRADE_SKILL_SHOW");
	BActionMain:RegisterEvent("TRADE_SKILL_CLOSE");
	BActionMain:RegisterEvent("UNIT_HEALTH");
	BActionMain:RegisterEvent("UNIT_MANA");
	BActionMain:RegisterEvent("UNIT_RAGE");
	BActionMain:RegisterEvent("UNIT_FOCUS");
	BActionMain:RegisterEvent("UNIT_ENERGY");
	BActionMain:RegisterEvent("PLAYER_ENTER_COMBAT");
	BActionMain:RegisterEvent("PLAYER_LEAVE_COMBAT");
	BActionMain:RegisterEvent("PLAYER_COMBO_POINTS");
	BActionMain:RegisterEvent("START_AUTOREPEAT_SPELL");
	BActionMain:RegisterEvent("STOP_AUTOREPEAT_SPELL");
	
	BActionMain:RegisterEvent("UNIT_INVENTORY_CHANGED");
	BActionMain:RegisterEvent("ACTIONBAR_SLOT_CHANGED");
end

function BActionMain_OnEvent()
	if( event == "ACTIONBAR_SLOT_CHANGED") then
		BActionMain_OnSlotChanged(arg1);
	elseif ( ( arg1 == "player" and ( event == "UNIT_MANA" or event == "UNIT_HEALTH" or event == "UNIT_RAGE" or event == "UNIT_FOCUS" or event == "UNIT_ENERGY" ) ) or event == "PLAYER_COMBO_POINTS" ) then
		BActionMain_ForAllShownButtons(BActionButton_UpdateUsable);
	elseif ( event == "UNIT_AURASTATE" and ( arg1 == "player" or arg1 == "target" ) ) then
		BActionMain_ForAllShownButtons(BActionButton_UpdateUsable);
	elseif ( event == "PLAYER_TARGET_CHANGED" or event == "PLAYER_AURAS_CHANGED" or event == "UPDATE_BONUS_ACTIONBAR" or event == "ACTIONBAR_PAGE_CHANGED" ) then
		BActionMain_ForAllButtons(BActionButton_UpdateAll);
	elseif ( event == "ACTIONBAR_UPDATE_COOLDOWN" or event == "ACTIONBAR_UPDATE_USABLE" or event == "UPDATE_INVENTORY_ALERTS") then
		BActionMain_ForAllShownButtons(BActionButton_UpdateUsableAndCooldown);
	elseif ( event == "ACTIONBAR_UPDATE_STATE" ) then
		BActionMain_ForAllShownButtons(BActionButton_UpdateState);
	elseif ( event == "PLAYER_ENTER_COMBAT" ) then
		IN_ATTACK_MODE = 1;
		BActionMain_ForAllShownButtons(BActionButton_UpdateFlash);
	elseif ( event == "PLAYER_LEAVE_COMBAT" ) then
		IN_ATTACK_MODE = nil;
		BActionMain_ForAllShownButtons(BActionButton_UpdateFlash);
	elseif( event == "START_AUTOREPEAT_SPELL" ) then
		IN_AUTOREPEAT_MODE = 1;
		BActionMain_ForAllShownButtons(BActionButton_UpdateFlash);
	elseif ( event == "STOP_AUTOREPEAT_SPELL" ) then
		IN_AUTOREPEAT_MODE = nil;
		BActionMain_ForAllShownButtons(BActionButton_UpdateFlash);
	elseif ( event == "UNIT_INVENTORY_CHANGED" and arg1=="player" ) then
		BActionMain_ForAllShownButtons(BActionButton_Update);
	elseif ( event == "CRAFT_SHOW" or event == "CRAFT_CLOSE" or event == "TRADE_SKILL_SHOW" or event == "TRADE_SKILL_CLOSE" ) then
		BActionMain_ForAllShownButtons(BActionButton_UpdateState);
	elseif ( event == "ACTIONBAR_SHOWGRID" ) then
		bg_showGrid = 1;
		BActionMain_ForAllButtons(BActionButton_ShowGrid);
	elseif ( event == "ACTIONBAR_HIDEGRID" ) then
		bg_showGrid = nil;
		if ( not Bongos.showGrid )  then
			BActionMain_ForAllButtons(BActionButton_HideGrid);
		end
	elseif ( event == "UPDATE_BINDINGS" ) then
		BActionMain_ForAllButtons(Bongos_UpdateHotkey);
	end
end

function BActionMain_OnSlotChanged(id)
	local bar, button, i, j, start;
	
	for i = 1, Bongos.numActionBars do
		local bar = getglobal("BActionBar" .. i);
		if( bar and bar:IsShown() ) then
			start = math.floor(120 / Bongos.numActionBars) *(i - 1) + 1;
			for j = start, start + Bongos[i].size - 1 do
				button = getglobal("BActionButton" .. j);
				if(button and BActionButton_GetPagedID(button:GetID()) == id ) then
					BActionButton_Update(button);
				end
			end
		end
	end
end

--Update a specific bar
function BActionMain_UpdateBar(barID)
	if(not (getglobal("BActionBar" .. barID) and Bongos[barID]) ) then
		return;
	end
	
	local button;
	local i = 1;
	local start = math.floor(120 / Bongos.numActionBars) *(barID - 1) + 1;
	for i = start, start + Bongos[barID].size - 1 do
		button = getglobal("BActionButton" .. i);
		if(button) then
			BActionButton_Update( button );
			BActionButton_UpdateState( button );
		else
			break;
		end
	end
end

--Enable/disable the OnUpdate depending on if contextual paging or button mashing prevention is on
function BActionMain_UpdateOnUpdate()
	if(Bongos.preventMash) then
		BActionMain:Show();
		return;
	end
	
	local i;
	for i = 1, Bongos.numActionBars do
		if( getglobal("BActionBar" .. i) and Bongos[i].inContext ) then
			BActionMain:Show();
			return;
		end
	end
	BActionMain:Hide();
end

--[[
	sets how many actionbars to use
	this is a highly destructive operation, as it resets the position of all bars. 
	This is done to make it easier to layout bars after adjusting the amount of them.
--]]
function BActionMain_SetNumberOfBars(numBars)
	local diff = numBars - Bongos.numActionBars;
	if(diff ~= 0) then
	
		for i = 1, Bongos.numActionBars do
			BActionBar_Delete();
		end
		
		Bongos.numActionBars = numBars;
		for i = 1, Bongos.numActionBars do
			BActionBar_Create();
		end	
		BActionMain_UpdateOnUpdate();
	end
end

--[[ Replacements for Blizzard Functions ]]--

--increment page
function BActionBar_PageUp()
	CURRENT_ACTIONBAR_PAGE = CURRENT_ACTIONBAR_PAGE + 1;
	if(CURRENT_ACTIONBAR_PAGE > Bongos.numActionBars) then
		CURRENT_ACTIONBAR_PAGE = 1;
	end
	ChangeActionBarPage();
end

--decrement page
function BActionBar_PageDown()
	CURRENT_ACTIONBAR_PAGE = CURRENT_ACTIONBAR_PAGE - 1;
	if(CURRENT_ACTIONBAR_PAGE < 1) then
		CURRENT_ACTIONBAR_PAGE = Bongos.numActionBars;
	end
	ChangeActionBarPage();
end

--[[ Helper Functions ]]--

--The use of these is most likely less efficient than direct calls, but it makes the code quite a bit cleaner looking

function BActionMain_ForAllButtons(action, arg1)
	local button, i, j, start;
	
	for i = 1, Bongos.numActionBars do
		if( getglobal("BActionBar" .. i) ) then	
			start = math.floor(120 / Bongos.numActionBars) *(i - 1) + 1;
			for j = start, start + Bongos[i].size - 1 do
				button = getglobal("BActionButton" .. j);
				if( button and button:GetParent() ) then
					action(button, arg1);
				else
					break;
				end
			end
		end
	end
end

function BActionMain_ForAllShownButtons(action, arg1)
	local bar, button, i, j, start;
	
	for i = 1, Bongos.numActionBars do
		bar = getglobal("BActionBar" .. i);
		if( bar and bar:IsShown() ) then
			start = math.floor(120 / Bongos.numActionBars) *(i - 1) + 1;
			for j = start, start + Bongos[i].size - 1 do
				button = getglobal("BActionButton" .. j);
				if(button) then
					action(button, arg1);
				else
					break;
				end
			end
		end
	end
end