--[[
		config.lua
			General functions for configuring Bongos
--]]

function Bongos_ToggleLock(enable)
	if(enable) then
		Bongos.locked = 1;	
		Bongos_ForEachBar(BBar_Lock);
	else
		Bongos.locked = nil;
		Bongos_ForEachBar(BBar_Unlock);
	end
end

--Show/Hide empty buttons
function Bongos_ToggleGrid(enable)
	if(enable) then	
		Bongos.showGrid = 1;
		BActionMain_ForAllButtons(BActionButton_ShowGrid);
		BPetBar_ShowGrid();
	else
		Bongos.showGrid = nil;
		BActionMain_ForAllButtons(BActionButton_HideGrid);
		BPetBar_HideGrid();
	end
end

function Bongos_SetQuickMoveMode(mode)
	Bongos.quickMove = mode;
end

--Enable/disable altcast
function Bongos_SetAltCastMode(mode)
	Bongos.altCast = mode;
end

--Enable/disable selfcast
function Bongos_ToggleSelfCast(enable)
	if(enable) then
		Bongos.selfCast = 1;
	else
		Bongos.selfCast = nil;
	end
end

--Enable/disable contextual paging
function Bongos_TogglePaging(bar, enable)

	if(enable) then
		Bongos[bar].paging = 1;
	else
		Bongos[bar].paging = nil;
	end
	
	BActionMain_UpdateBar(bar);
end

--Enable/disable contextual paging
function Bongos_ToggleContextualPaging(bar, enable)

	if(enable) then
		Bongos[bar].inContext = 1;
	else
		Bongos[bar].inContext = nil;
	end
	
	BActionMain_UpdateBar(bar);
	BActionMain_UpdateOnUpdate();
end

--Hide/Show macro text on action buttons
function Bongos_ToggleMacroText(enable)
	if(enable) then
		BActionMain_ForAllButtons(BActionButton_ShowMacroText);
		Bongos.hideMacro = nil;
	else
		BActionMain_ForAllButtons(BActionButton_HideMacroText);
		Bongos.hideMacro = 1;
	end
end

--Hide/Show macro text on action buttons
function Bongos_ToggleHotkeys(enable)
	if(enable) then
		BActionMain_ForAllButtons(BActionButton_ShowHotkeys);
		BClassBar_ShowHotkeys();
		BPetBar_ShowHotkeys();
		Bongos.hideHotkeys = nil;
	else
		BActionMain_ForAllButtons(BActionButton_HideHotkeys);
		BClassBar_HideHotkeys();
		BPetBar_HideHotkeys();
		Bongos.hideHotkeys = 1;
	end
end

--enable/disable range coloring
function Bongos_ToggleRange(enable)
	if( enable ) then
		Bongos.color = 1;
	else
		Bongos.color = nil;
	end
	BActionMain_ForAllShownButtons(BActionButton_UpdateUsable);
end

--enable/disable the moving of buttons on the action bars/pet bar
function Bongos_ToggleButtonLock(enabled)
	if(enabled) then
		Bongos.buttonLocked = 1;
	else
		Bongos.buttonLocked = nil;
	end
end

--enable disable "sticky" bars
function Bongos_ToggleStickyBars(enabled)
	if(enabled) then
		Bongos.sticky = 1;
	else
		Bongos.sticky = nil;
		
		--watch people hate that I unsticky all bars if the option is turned off.
		Bongos_ForEachBar(BBar_ReAnchor);	
		if(BCastBar) then
			BBar_ReAnchor(BCastBar);
		end
	end
end

function Bongos_ToggleVisibility(id, show)
	if(show) then
		Bongos_ForBarID(id, BBar_Show);
	else
		Bongos_ForBarID(id, BBar_Hide);
	end
end

function Bongos_SetRangeColor(red, green, blue)
	if(red and green and blue) then
		Bongos.rangeColor = {r = red, g = green, b = blue};
	end
end