if not SimpleCombatLog then return end

local dewdrop = AceLibrary("Dewdrop-2.0")
local L = {

	["Load Theme"] = "Load Theme",
	["Save Theme"] = "Save Theme",
	["Delete Theme"] = "Delete Theme",
	["Add new Theme"] = "Add new Theme",

}



function SimpleCombatLog:SaveTheme(id, themeName)
	if self.settings[id].theme then return end -- It is already a theme, noneed to save.
	
	local theme = self.settings[id]
	theme.theme = themeName
	
	self.themes[themeName] = theme
	self.themeDB[themeName] = theme
	
	self.settingDB[id] = themeName
		
end


local function ThemeMenuSettings(self, id, level, value)
	if level == 1 then
	
		dewdrop:AddLine()
		
		dewdrop:AddLine(
			'text', L["Load Theme"],
			'hasArrow', true,
			'notCheckable', true,
			'value', 'LoadTheme'
		)

		
		if not self:GetValue(id, 'theme') then
			dewdrop:AddLine(
				'text', L["Save Theme"],
				'hasArrow', true,
				'notCheckable', true,
				'value', 'SaveTheme'
			)
		end
		
		dewdrop:AddLine(
			'text', L["Delete Theme"],
			'hasArrow', true,
			'notCheckable', true,
			'value', 'DeleteTheme'
		)
	elseif level == 2 then
		if value == 'LoadTheme' then
			for themeName, themeTable in pairs(self.themes) do
				local themeName = themeName
				local themeTable = themeTable
				local title
				if self.themeDB[themeName] then
					title = string.format("|cffeda55f%s|r", themeName)
				else
					title = themeName
				end
					
				dewdrop:AddLine(
					'text', title,
					'func', function() self:SetTheme(id, themeTable) end,
					'checked', (self:GetValue(id, 'theme') == themeName )
				)
			end			
		
		elseif value == 'SaveTheme' then
			for themeName, themeTable in pairs(self.themes) do
				local themeName = themeName
				local themeTable = themeTable
				dewdrop:AddLine(
					'text', themeName,
					'func', function() self:SaveTheme(id, themeName) end
				)
			end	
			dewdrop:AddLine(
				'text', L["Add new Theme"],
				'hasArrow', true,
				'hasEditBox', true,
				'editBoxFunc', function(text) self:SaveTheme(id, text) end
			)
		
		elseif value == 'DeleteTheme' then
			dewdrop:AddLine(
				'text', "Not yet implemented"
			)
		end
	
	end
end


SimpleCombatLog.ThemeMenuSettings = ThemeMenuSettings
