--[[
Name: idChat2_Justify
Developed by: Curney of Uther
Inspired by: ChatJustify by MoonWolf
Thanks to: Wubin for helping me understand variables better
Description: Module for idChat2 that sets the justification for chat windows.
Dependencies: idChat2
]]

idChat2_Justify = idChat2:NewModule('justify')

local db = idChat2.db.profile

function idChat2_Justify:OnInitialize()

    if not db.Justify then
        db.Justify = {
            on = true,
            default = "LEFT",
            chatframe = {}
        }
        for i=1,7 do
            db.Justify.chatframe[i] = "LEFT"
        end
    end

    idChat2.Options.args.justify = {
        name = "Justify",
        desc = "Set justification of chat windows.",
        type = "group",
        args = {
            toggle = {
                name = "Toggle",
                desc = "Toggle the module on and off",
                type = "toggle",
                get = function() return db.Justify.on end,
                set = function(v)
                    if v then
                        self:OnEnable()
                    else
                        self:OnDisable()
                    end
                    db.Justify.on = v
                end
            },
        		chatframe1 = {
        			 name = "ChatFrame1",
        	    	 type = "text",
        	    	 desc = "justified",
        	    	 get = function() return db.Justify.chatframe[1] end,
        	    	 set = function(v)
                    db.Justify.chatframe[1] = v
                    self:Set(1,v)
                end,
        	    	 validate = {["LEFT"] = "Left", ["RIGHT"] = "Right", ["CENTER"] = "Center"}
        		},
        		chatframe2 = {
                name = "ChatFrame2",
        	    	 type = "text",
        	    	 desc = "justified",
        	    	 get = function() return db.Justify.chatframe[2] end,
        	    	 set = function(v)
                    db.Justify.chatframe[2] = v
                    self:Set(2,v)
                end,
        	    	 validate = {["LEFT"] = "Left", ["RIGHT"] = "Right", ["CENTER"] = "Center"}
        		},
        		chatframe3 = {
        			 name = "ChatFrame3",
        	    	 type = "text",
        	    	 desc = "justified",
        	    	 get = function() return db.Justify.chatframe[3] end,
        	    	 set = function(v) 
                    db.Justify.chatframe[3] = v
                    self:Set(3,v)
                end,
        	    	 validate = {["LEFT"] = "Left", ["RIGHT"] = "Right", ["CENTER"] = "Center"}
        		},
        		chatframe4 = {
        			 name = "ChatFrame4",
        	    	 type = "text",
        	    	 desc = "justified",
        	    	 get = function() return db.Justify.chatframe[4] end,
        	    	 set = function(v)
                    db.Justify.chatframe[4] = v
                    self:Set(4,v)
                end,
        	    	 validate = {["LEFT"] = "Left", ["RIGHT"] = "Right", ["CENTER"] = "Center"}
        		},
        		chatframe5 = {
        			 name = "ChatFrame5",
        	    	 type = "text",
        	    	 desc = "justified",
        	    	 get = function() return db.Justify.chatframe[5] end,
        	    	 set = function(v)
                    db.Justify.chatframe[5] = v
                    self:Set(5,v)
                end,
        	    	 validate = {["LEFT"] = "Left", ["RIGHT"] = "Right", ["CENTER"] = "Center"}
        		},
        		chatframe6 = {
        			 name = "ChatFrame6",
        	    	 type = "text",
        	    	 desc = "justified",
        	    	 get = function() return db.Justify.chatframe[6] end,
        	    	 set = function(v)
                    db.Justify.chatframe[6] = v
                    self:Set(6,v)
                end,
        	    	 validate = {["LEFT"] = "Left", ["RIGHT"] = "Right", ["CENTER"] = "Center"}
        		},
        		chatframe7 = {
        			 name = "ChatFrame7",
        	    	 type = "text",
        	    	 desc = "justified",
        	    	 get = function() return db.Justify.chatframe[7] end,
        	    	 set = function(v)
                    db.Justify.chatframe[7] = v
                    self:Set(7,v)
                end,
        	    	 validate = {["LEFT"] = "Left", ["RIGHT"] = "Right", ["CENTER"] = "Center"}
        		}
        }
    }
end

function idChat2_Justify:OnEnable()
    for i=1,7 do
        self:Set(i,db.Justify.chatframe[i])
    end
end

function idChat2_Justify:OnDisable()
    for i=1,7 do
        self:Set(i,db.Justify.default)
    end
end

function idChat2_Justify:Set(frame,justification)
    local a = getglobal("ChatFrame"..frame)
    a:SetJustifyH(justification)
end
